﻿using LastFMLib;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Text;
using System.Xml;

namespace Test
{
    class Program
    {
        enum CHOICE { COMPLETE_REGISTRATION, REGISTRATION_FROM_TOKEN, SCROBBLE, TRACK_INFO };

        static void Main(string[] args)
        {
            string apiKey = "<your app key>";
            string secret = "<your app secret>";

            string appName = "<your app name>";
            string appVersion = "<your app version>";
            string appHomepage = "<your app site>";

            LastFMClient lastFM = new LastFMClient(apiKey, secret);

            lastFM.UserAgent = String.Format("{0}/{1} ({2}))", appName, appVersion, appHomepage);

            //lastFM.Proxy = new System.Net.WebProxy("proxy", 8080);

            //lastFM.Proxy.Credentials = new NetworkCredential("user", "password", "domain");

            Dictionary<string, string> param = new Dictionary<string, string>();

            CHOICE choice = CHOICE.TRACK_INFO;

            string token = null;
            string sig = null;
            string xml = null;

            XmlDocument xmlDoc = new XmlDocument();

            switch (choice)
            {
                case CHOICE.COMPLETE_REGISTRATION:

                    sig = lastFM.GenerateSignature("auth.getToken", param);

                    param.Add("api_sig", sig);

                    xml = lastFM.CallMethod("auth.getToken", param);

                    xmlDoc.LoadXml(xml);

                    token = xmlDoc.GetElementsByTagName("token")[0].InnerText;

                    string url = lastFM.GetRequestAuthUrl(token);

                    Process.Start(url);

                    Console.WriteLine("Accept the application request and then press enter");

                    Console.ReadLine();

                    param.Add("token", token);

                    param.Remove("api_sig");

                    sig = lastFM.GenerateSignature("auth.getSession", param);

                    param.Add("api_sig", sig);

                    xml = lastFM.CallMethod("auth.getSession", param);

                    xmlDoc.LoadXml(xml);

                    string name = xmlDoc.GetElementsByTagName("name")[0].InnerText;

                    string session = xmlDoc.GetElementsByTagName("key")[0].InnerText;

                    Console.WriteLine("token: {0}", token);
                    Console.WriteLine("name: {0}", name);
                    Console.WriteLine("session: {0}", session);

                    break;

                case CHOICE.REGISTRATION_FROM_TOKEN:

                    token = "<your given token>";

                    param.Add("token", token);

                    sig = lastFM.GenerateSignature("auth.getSession", param);

                    param.Add("api_sig", sig);

                    xml = lastFM.CallMethod("auth.getSession", param);

                    xmlDoc.LoadXml(xml);

                    name = xmlDoc.GetElementsByTagName("name")[0].InnerText;

                    session = xmlDoc.GetElementsByTagName("key")[0].InnerText;

                    Console.WriteLine("token: {0}", token);
                    Console.WriteLine("name: {0}", name);
                    Console.WriteLine("session: {0}", session);

                    break;

                case CHOICE.SCROBBLE:

                    session = "<your given session>";

                    param.Add("sk", session);
                    param.Add("artist[0]", "Fabrizio Stellato");
                    param.Add("track[0]", "Twin Trix Hi Scores");
                    param.Add("timestamp[0]", LastFMClient.GetUnixTimeNow().ToString());

                    sig = lastFM.GenerateSignature("track.scrobble", param);
                    param.Add("api_sig", sig);

                    xml = lastFM.CallMethod("track.scrobble", param, BaseWService.REQUEST_METHOD.POST);

                    xmlDoc.LoadXml(xml);

                    XmlNodeList nodeList = xmlDoc.GetElementsByTagName("scrobbles");
                    XmlNode node = nodeList.Item(0);

                    string accepted = node.Attributes["accepted"].Value;
                    string ignored = node.Attributes["ignored"].Value;

                    Console.WriteLine("accepted: {0}", accepted);
                    Console.WriteLine("ignored: {0}", ignored);

                    break;

                case CHOICE.TRACK_INFO:

                    Console.WriteLine("Calling LastFM track.GetInfo...\n\n");

                    param.Add("artist", "Fabrizio Stellato");
                    param.Add("track", "TwinTrix Main theme");

                    xml = lastFM.CallMethod("track.getInfo", param);

                    xmlDoc.LoadXml(xml);

                    nodeList = xmlDoc.SelectNodes("//album/title");

                    string title = xmlDoc.SelectNodes("//track/name").Item(0).InnerText;

                    string artist = xmlDoc.SelectNodes("//artist/name").Item(0).InnerText;

                    string album = "";

                    if (nodeList.Count > 0)
                    {
                        album = xmlDoc.SelectNodes("//album/title").Item(0).InnerText;
                    }

                    Console.WriteLine("title: {0}", title);
                    Console.WriteLine("artist: {0}", artist);
                    Console.WriteLine("album: {0}", album);

                    break;

            }

            Console.ReadLine();
        }
    }
}
